/**
 * editShell
 */
import { notify } from '../../../../pi/widget/event';
import { Widget } from '../../../../pi/widget/widget';
import { popNewMessage } from '../../util/logic';

import { execShell } from '../../net/rpc';

export class EditShell extends Widget {
    public props:any = {
        name:'',
        content:''
    };

    // 取消编辑
    public close(e:any,value:boolean= false) {
        notify(e.node,'ev-editMana-cancel',{ value:value });
    }

    // 修改名字
    public changeName(e:any) {
        this.props.name = e.value;
    }

    // 修改内容
    public changeContent(e:any) {
        this.props.content = e.value;
    }

    // 保存
    public save(e:any) {
        if (this.props.name && this.props.content) {
            notify(e.node,'ev-editShell',{ value:[this.props.name,this.props.content] });
        } else {
            popNewMessage('请输入完整','error');
        }
    }

    // 执行
    public exeCommand() {
        if (this.props.name && this.props.content) {
            execShell(this.props.content, r => {
                this.props.shellResult = r;
                this.paint()
            })
        } else {
            popNewMessage('请输入完整','error');
        }
    }
}