/**
 * rpc调用
 */
import { Forelet } from '../../../../pi/widget/forelet';
import { Widget } from '../../../../pi/widget/widget';
import { clientRpcFunc } from '../../net/init';
import { callArbitaryRpc, getAllRpcsPath, getHttpRpcs, structNameHash, getMigrateDataTables, deleteTempDataTable, writeBackData, migrationTable } from '../../net/rpc';
import { deepCopy, register } from '../../store/memstore';
import { popNewMessage } from '../../util/logic';
interface Props {
    txt:string;  // 输入的内容
    path:string; // 选中的rpc方法路径
    placeHolder:string;  // 默认提示内容
    rpcList:string[]; 
    funcList:string[];
    rpcFullPath: string[];
}
export const forelet = new Forelet();

export class RpcFunc extends Widget {
    public ok:() => void;
    public props:Props = {
        txt:'',
        path:'',
        placeHolder:'',
        rpcList:[],
        funcList:[],
        rpcFullPath: [] 
    };

    public create() {
        super.create();
        getMigrateDataTables((r) => {
            console.log('rrrrrr table ', r);
            this.props.rpcFullPath = r;
            const s = new Set<string>();
            for (const rpc of r) {
                s.add(rpc.split(':')[0]);
            }
            this.props.rpcList = [...r];
            this.paint();
        })
    }

    // 关闭右侧输入框
    public close() {
        this.props.path = '';
        this.paint();
    }

    // 选择rpc
    public select(ind:number) {
        if (this.props.rpcList[ind] !== this.props.path) {
            this.props.path = this.props.rpcList[ind];
            const funcs = [];
            for (const rpc of this.props.rpcFullPath) {
                // console.log('rpc, path ', rpc, this.props.path)
                if (rpc.split('.')[0] === this.props.path) {
                    funcs.push(rpc.split('.')[1]);
                }
            }
            this.props.funcList = funcs;
        } else {
            this.props.path = '';
            this.props.funcList = [];
        }
        
        this.paint();
    }
    
    // 输入命令
    public commandInput(e:any) {
        this.props.txt = e.value;
    }

    public migrateData() {
        for (const tab of this.props.rpcList) {
            // writeBackData()
            const [oldTab, tmpTab] = tab.split(':');
            console.log('oldTab , tmpTab --- ', oldTab, tmpTab);
            migrationTable(oldTab, (_r) => {
                writeBackData(oldTab, tmpTab, r => {
                    if (r) {
                        popNewMessage('写入数据成功');
                    } else {
                        popNewMessage('写入数据失败');
                    }
                });
            })
        }

        console.log('list ---', this.props.rpcList)
    }

    public deleteTempTable() {
        for (const tab of this.props.rpcList) {
            const [_, tmpTab] = tab.split(':');
            deleteTempDataTable(tmpTab, r => {
                popNewMessage('删除临时表成功');
                console.log('delete temp tab -- ', tmpTab, r);
            })
        }
    }
}
register(`rpcResultMap`,(r) => {
    forelet.paint(JSON.stringify(r));
});