/**
 * user
 */
import { popNew } from '../../../../pi/ui/root';
import { Widget } from '../../../../pi/widget/widget';
import { delUser, listAllUser } from '../../net/rpc';
import { popNewMessage } from '../../util/logic';
import { PowerList } from './editManager';
interface Props {
    titles:string[];
    datas:any[];
    showDatas:any[];
    editable:boolean;  // 是否编辑用户
    editName:string;   // 被编辑的用户
    editPower:number[];  // 被编辑的用户权限
}

export class UserManage extends Widget {
    public props:Props = {
        titles:['用户名','权限','角色'],
        datas:[
            ['111', [0,1,2]]
        ],
        showDatas:[],
        editable:false,
        editName:'',
        editPower:[]
    };    

    public create() {
        super.create();
        this.init();
    }

    public init() {
        listAllUser((r) => {
            this.props.datas = r.map(item => {
                return [
                    item.userName,
                    item.authList
                ];
            });

            this.props.showDatas = this.props.datas.map(item => {
                const res = [];
                for (const i of item[1]) {
                    res.push(PowerList[i]);
                }
    
                return [
                    item[0],
                    res.join('，'),
                    item[1].indexOf(2) > -1 ? '管理员' :'客服'
                ];
                    
            });
            this.paint();
        });
    }

    public edit(e:any) {
        this.props.editable = true;
        this.props.editName = this.props.datas[e.value][0];
        this.props.editPower = this.props.datas[e.value][1];
        this.paint();
    }

    public closeEdit(e:any) {
        this.props.editable = false;
        this.props.editName = '';
        this.props.editPower = [];
        if (e.value) {  // 成功添加或修改了用户数据
            this.init();
        }
        this.paint();
    }

    public addMana(num:number) {
        if (num) {
            this.props.editPower = [0,1,2];
        } else {
            this.props.editPower = [0,1];
        }
        this.props.editable = true;
        this.paint();
    }

    public remove(e:any) {
        const item = this.props.datas[e.index];
        popNew('management-client-components-modalBox',{ content:`删除用户 "<span style='color:#3294e6'>${item[0]}</span>"` },() => {
            delUser(item[0],(r) => {
                console.log('删除用户',r);
                if (r && r.code === 1) {
                    this.props.showDatas.splice(e.index,1);
                    popNewMessage('删除用户成功');
                    this.paint();
                } else {
                    popNewMessage('删除用户失败','error');
                }
            });
        });
        
    }
}