/**
 * 数据库筛选
 */

// ================================================ 导入
import { notify } from '../../../pi/widget/event';
import { Widget } from '../../../pi/widget/widget';

// ================================================ 导出

interface Props {
    optionList:any[];// 选项列表
    checked:number; // 选中的下标
    show:boolean;// 是否显示列表  1显示 0不显示
    title:string; // 不选择是默认名称
    mustChoose:boolean; // 是否必须选中一个
}

// tslint:disable-next-line:completed-docs
export class DatabaseFilter extends Widget {
    public props:Props = {
        optionList:[],
        checked:-1,
        show:false,
        title:'所有',
        mustChoose:false
    };
    public setProps(props:any) {
        this.props = {
            ...this.props,
            ...props
        };
        super.setProps(this.props);
    }
    // 点击展开
    public expand(e:any) {
        this.props.show = !this.props.show;
        notify(e.node,'ev-showBox-change',{ value:this.props.show });
        this.paint();
    }
    // 选择筛选条件
    public select(e:any,index:number) {
        if (this.props.checked !== index) {
            this.props.checked = index;
            notify(e.node,'ev-database-change',{ value:this.props.optionList[index],index:index });     

        } else if (!this.props.mustChoose) {
            this.props.checked = -1;
            notify(e.node,'ev-database-change',{ value:this.props.optionList[index],index:-1 });
        }
        this.props.show = false;
        this.paint();
    }
}