/**
 * 选择框
 */

// ================================================ 导入
import { notify } from '../../../pi/widget/event';
import { Widget } from '../../../pi/widget/widget';

// ================================================ 导出
interface Props {
    active:number[]; // 当前选择的选项
    options:any[];// 所有选项 ['name', {mfa}]
    hasTitle:any;// 是否有标题 ['name', ... selected]  最后一项selected表示标题是否被选中
    allSelected:boolean; // 是否全选 即选中标题
}

// tslint:disable-next-line:completed-docs
export class SelectBox extends Widget {
    public props:Props = {
        active:[],
        options:[],
        hasTitle:null,
        allSelected:false
    };

    public setProps(props:any) {
        this.props = {
            ...this.props,
            ...props
        };
        super.setProps(this.props);
        if (this.props.hasTitle) {
            this.props.allSelected = this.props.hasTitle[this.props.hasTitle.length - 1];
        }
    }

    public select(e:any,num:number) {
        if (num === -1) {
            this.props.allSelected = !this.props.allSelected;
            this.props.hasTitle[this.props.hasTitle.length - 1] = this.props.allSelected;
            this.props.active = [];
            if (this.props.allSelected) { 
                let len = 0;
                while (len < this.props.options.length) {
                    this.props.active.push(len);
                    len++;
                }
            }
            notify(e.node,'ev-select-option',{ value: this.props.hasTitle[1], selected: this.props.allSelected, activeOptions: this.props.active });
        } else {
            const index = this.props.active.indexOf(num);
            if (index < 0) {
                this.props.active.push(num);
            } else {
                this.props.active.splice(index,1);
                this.props.allSelected = false; // 取消其中一个则全选置为false
            }
            this.props.active.sort(cmd);

            notify(e.node,'ev-select-option',{ value: this.props.options[num][1], selected: index < 0, activeOptions: this.props.active });
        }
        this.paint();
    }
}

// ================================================ 本地
export const cmd = (v1,v2) => {
    return v1 - v2;
};