/**
 * Server configuration
 */
/**
 * 服务器配置
 */
import { cfgMgr } from '../../../pi/util/cfg';
import { AsyncCfg, GlobalMqttServerCfg, HttpsCfg, HttpsTlsCfg, MqttCfg, NetCfg, NetCfg_Enum, RawNetCfg, RawNetMgr, RpcCfg as NewRpcCfg, TlsNetCfg, TlsNetMgr } from '../../../pi_pt/init/server_cfg.s';

// 新的rpc配置方式   新的配置方式启动
const newRpcCfg = new NewRpcCfg([]);
const globalMqttServerCfg = new GlobalMqttServerCfg('0.0.0.0', [2234], 1024 * 16, 1024 * 16, 1024 * 16, 16, 10000, 1024 * 1024 * 2, 10, 'mqttv3.1');
cfgMgr.set(NewRpcCfg._$info.name, new Map<number, any>([[0, newRpcCfg]]));
cfgMgr.set(GlobalMqttServerCfg._$info.name, new Map<number, any>([[0, globalMqttServerCfg]]));

const asyncCfg = new AsyncCfg([]);
const genHead = new Map();
genHead.set('Access-Control-Allow-Origin', '*');
//
const httpsCfg = new HttpsCfg('0.0.0.0', 9090, 5000, 10000, '../dst/', '../src/', genHead);
const httpsCfg1 = new HttpsCfg('0.0.0.0', 8081, 5000, 10000, '../miniGame/', '../src/');

cfgMgr.set(AsyncCfg._$info.name, new Map<number, any>([[0, asyncCfg]]));
cfgMgr.set(HttpsCfg._$info.name, new Map<number, any>([[0, httpsCfg], [1, httpsCfg1]]));

// // 启动http与ws
// const rawNetMgr = new RawNetMgr('rawNetMgr', []);
// const rawNetCfg = new NetCfg(NetCfg_Enum.Raw, new RawNetCfg('0.0.0.0:9080', 'tcp', true, rawNetMgr, []));
// const mqttCfg = new MqttCfg(rawNetCfg, 1024 * 1024, 500 * 1000, 'mqttServer', []);
// const rpcCfg = new RpcCfg(mqttCfg, 'rpcServer', ['mqttServer']);
// const asyncCfg = new AsyncCfg([]);
// const httpsCfg = new HttpsCfg('0.0.0.0', 8081, 5000, 10000, '../../gaia_wallet_webserver/plugin/wallet/htdocs/.res/wallet');

// cfgMgr.set(RawNetMgr._$info.name, new Map<number,any>([[0, rawNetMgr]]));
// cfgMgr.set(NetCfg._$info.name, new Map<number,any>([[0, rawNetCfg]]));
// cfgMgr.set(MqttCfg._$info.name, new Map<number, any>([[0, mqttCfg]]));
// cfgMgr.set(RpcCfg._$info.name, new Map<number, any>([[0, rpcCfg]]));
// cfgMgr.set(AsyncCfg._$info.name, new Map<number,any>([[0, asyncCfg]]));
// cfgMgr.set(HttpsCfg._$info.name, new Map<number,any>([[0, httpsCfg]]));