enum DBOperation {
    ADD = 1,
    DEL = 2,
    MOD = 3,
    QUERY = 4,
}

//读取数据
struct Read {
    op: DBOperation,
    ware: String,
    tab: String, //表名
    keys: [u8],  //表键(需要自己序列化和反序列化)
}

//遍历表数据
struct Select {
    op: DBOperation,
    ware: String,
    tab: String,
    startKey: [u8], // 为[undefined/null]表示从头迭代所有数据， 不为空表示从star开始迭代
    endKey: [u8],
    pagination: u32,
    direction: bool,
}

//写表数据
struct Write {
    op: DBOperation,
    ware: String,
    tab: String,
    key: [u8],
    value: [u8], //value为空表示删除数据
}

struct MetaInfo {
    ware: String,
    tab: String,
}
