struct WriteDBReq {
    ware: str,
    tab: str,
    key: [u8],
    value: Option<[u8]>,
}

struct ReadDBReq {
    ware: str,
    tab: str,
    key: [u8],
}

struct ReadDBResp {
    ware: str,
    tab: str,
    key: [u8],
    value: Option<[u8]>,
}

struct IterDBReq {
    ware: str,
    tab: str,
    startKey: [u8], // 为[undefined/null]表示从头迭代所有数据， 不为空表示从star开始迭代
    endKey: [u8],
    pagination: u32,
    direction: bool,
}

struct IterDBResp {
    msg: [u8]
}

struct TabMetaReq {
    ware: str,
    tab: str,
}

struct EncodeStructReq {
    structName: str,
    jstr: str, // json str
}

struct DecodeStructReq {
    structName: str,
    bin: [[u8]],
}

struct DecodeStructResp {
    res: [str]
}

struct WriteBackDataReq {
    tempTabName: str,
    oldTabName: str,
}

struct OK_I{
    value: usize,
}

struct OK_S{
    value: String,
}

struct Req{
    path: String,
}

struct Error{
    code: usize,
    info: String,
}

struct Ok{}