
import { EnumInfo, EnumType, FieldInfo, StructInfo, Type } from '../../../pi/struct/sinfo';
import { addToMeta, notifyModify, removeFromMeta, Struct, StructMgr, structMgr } from '../../../pi/struct/struct_mgr';
import { BonBuffer } from '../../../pi/util/bon';

export class WriteDBReq extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.WriteDBReq',3014944193, null, [new FieldInfo('ware', 
new EnumType(Type.Str), null), new FieldInfo('tab', 
new EnumType(Type.Str), null), new FieldInfo('key', 
new EnumType(Type.Arr, 
new EnumType(Type.U8)), null), new FieldInfo('value', 
new EnumType(Type.Option, 
new EnumType(Type.Arr, 
new EnumType(Type.U8))), null)]);

    public ware: string;
    public tab: string;
    public key: Uint8Array;
    public value: Uint8Array;

    public bonDecode(bb:BonBuffer) {
        (<any>this).ware = bb.readUtf8();
        (<any>this).tab = bb.readUtf8();
        (<any>this).key = bb.readBin()
;
        if (!bb.isNil()) {
            (<any>this).value = bb.readBin()
;
        }
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.ware);
                
        bb.writeUtf8(this.tab);
                
        bb.writeBin(this.key);
                
        if (this.value === undefined || this.value === null) {
            bb.writeNil();
        } else {    
            bb.writeBin(this.value);
            
        }
    }
}
structMgr.register(WriteDBReq._$info.name_hash, WriteDBReq, WriteDBReq._$info.name);

export class ReadDBReq extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.ReadDBReq',1608883454, null, [new FieldInfo('ware', 
new EnumType(Type.Str), null), new FieldInfo('tab', 
new EnumType(Type.Str), null), new FieldInfo('key', 
new EnumType(Type.Arr, 
new EnumType(Type.U8)), null)]);

    public ware: string;
    public tab: string;
    public key: Uint8Array;

    public bonDecode(bb:BonBuffer) {
        (<any>this).ware = bb.readUtf8();
        (<any>this).tab = bb.readUtf8();
        (<any>this).key = bb.readBin()
;
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.ware);
                
        bb.writeUtf8(this.tab);
                
        bb.writeBin(this.key);
        
    }
}
structMgr.register(ReadDBReq._$info.name_hash, ReadDBReq, ReadDBReq._$info.name);

export class ReadDBResp extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.ReadDBResp',3750054846, null, [new FieldInfo('ware', 
new EnumType(Type.Str), null), new FieldInfo('tab', 
new EnumType(Type.Str), null), new FieldInfo('key', 
new EnumType(Type.Arr, 
new EnumType(Type.U8)), null), new FieldInfo('value', 
new EnumType(Type.Option, 
new EnumType(Type.Arr, 
new EnumType(Type.U8))), null)]);

    public ware: string;
    public tab: string;
    public key: Uint8Array;
    public value: Uint8Array;

    public bonDecode(bb:BonBuffer) {
        (<any>this).ware = bb.readUtf8();
        (<any>this).tab = bb.readUtf8();
        (<any>this).key = bb.readBin()
;
        if (!bb.isNil()) {
            (<any>this).value = bb.readBin()
;
        }
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.ware);
                
        bb.writeUtf8(this.tab);
                
        bb.writeBin(this.key);
                
        if (this.value === undefined || this.value === null) {
            bb.writeNil();
        } else {    
            bb.writeBin(this.value);
            
        }
    }
}
structMgr.register(ReadDBResp._$info.name_hash, ReadDBResp, ReadDBResp._$info.name);

export class IterDBReq extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.IterDBReq',485593631, null, [new FieldInfo('ware', 
new EnumType(Type.Str), null), new FieldInfo('tab', 
new EnumType(Type.Str), null), new FieldInfo('startKey', 
new EnumType(Type.Arr, 
new EnumType(Type.U8)), null), new FieldInfo('endKey', 
new EnumType(Type.Arr, 
new EnumType(Type.U8)), null), new FieldInfo('pagination', 
new EnumType(Type.U32), null), new FieldInfo('direction', 
new EnumType(Type.Bool), null)]);

    public ware: string;
    public tab: string;
    public startKey: Uint8Array;
    public endKey: Uint8Array;
    public pagination: number;
    public direction: boolean;

    public bonDecode(bb:BonBuffer) {
        (<any>this).ware = bb.readUtf8();
        (<any>this).tab = bb.readUtf8();
        (<any>this).startKey = bb.readBin()
;
        (<any>this).endKey = bb.readBin()
;
        (<any>this).pagination = bb.readInt();
        (<any>this).direction = bb.readBool();
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.ware);
                
        bb.writeUtf8(this.tab);
                
        bb.writeBin(this.startKey);
                
        bb.writeBin(this.endKey);
                
        bb.writeInt(this.pagination);
                
        bb.writeBool(this.direction);
        
    }
}
structMgr.register(IterDBReq._$info.name_hash, IterDBReq, IterDBReq._$info.name);

export class IterDBResp extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.IterDBResp',293565787, null, [new FieldInfo('msg', 
new EnumType(Type.Arr, 
new EnumType(Type.U8)), null)]);

    public msg: Uint8Array;

    public bonDecode(bb:BonBuffer) {
        (<any>this).msg = bb.readBin()
;
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeBin(this.msg);
        
    }
}
structMgr.register(IterDBResp._$info.name_hash, IterDBResp, IterDBResp._$info.name);

export class TabMetaReq extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.TabMetaReq',618037205, null, [new FieldInfo('ware', 
new EnumType(Type.Str), null), new FieldInfo('tab', 
new EnumType(Type.Str), null)]);

    public ware: string;
    public tab: string;

    public bonDecode(bb:BonBuffer) {
        (<any>this).ware = bb.readUtf8();
        (<any>this).tab = bb.readUtf8();
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.ware);
                
        bb.writeUtf8(this.tab);
        
    }
}
structMgr.register(TabMetaReq._$info.name_hash, TabMetaReq, TabMetaReq._$info.name);

export class EncodeStructReq extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.EncodeStructReq',788429386, null, [new FieldInfo('structName', 
new EnumType(Type.Str), null), new FieldInfo('jstr', 
new EnumType(Type.Str), null)]);

    public structName: string;
    public jstr: string;

    public bonDecode(bb:BonBuffer) {
        (<any>this).structName = bb.readUtf8();
        (<any>this).jstr = bb.readUtf8();
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.structName);
                
        bb.writeUtf8(this.jstr);
        
    }
}
structMgr.register(EncodeStructReq._$info.name_hash, EncodeStructReq, EncodeStructReq._$info.name);

export class DecodeStructReq extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.DecodeStructReq',3568862670, null, [new FieldInfo('structName', 
new EnumType(Type.Str), null), new FieldInfo('bin', 
new EnumType(Type.Arr, 
new EnumType(Type.Arr, 
new EnumType(Type.U8))), null)]);

    public structName: string;
    public bin: Uint8Array[];

    public bonDecode(bb:BonBuffer) {
        (<any>this).structName = bb.readUtf8();
        (<any>this).bin = bb.readArray(() => {
            return     bb.readBin()
    ;
        })
;
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.structName);
                
        bb.writeArray(this.bin, (el) => {    
            bb.writeBin(el);
            
        });
        
    }
}
structMgr.register(DecodeStructReq._$info.name_hash, DecodeStructReq, DecodeStructReq._$info.name);

export class DecodeStructResp extends Struct {
    public static _$info =  new StructInfo('pi_pt/util/platmgr.DecodeStructResp',428795066, null, [new FieldInfo('res', 
new EnumType(Type.Arr, 
new EnumType(Type.Str)), null)]);

    public res: string[];

    public bonDecode(bb:BonBuffer) {
        (<any>this).res = bb.readArray(() => {
            return     bb.readUtf8();
        })
;
    }

    public bonEncode(bb:BonBuffer) {        
        bb.writeArray(this.res, (el) => {    
            bb.writeUtf8(el);
            
        });
        
    }
}
structMgr.register(DecodeStructResp._$info.name_hash, DecodeStructResp, DecodeStructResp._$info.name);

export class WriteBackDataReq extends Struct {

    tempTabName: string;
    oldTabName: string;
	static _$info =  new StructInfo("pi_pt/util/migration.WriteBackDataReq",588269782, null, [new FieldInfo("tempTabName", 
new EnumType( Type.Str ), null), new FieldInfo("oldTabName", 
new EnumType( Type.Str ), null) ]);






	bonDecode(bb:BonBuffer) {
		(<any>this).tempTabName = bb.readUtf8();
		(<any>this).oldTabName = bb.readUtf8();
	}


	bonEncode(bb:BonBuffer) {        
        bb.writeUtf8(this.tempTabName);
                
        bb.writeUtf8(this.oldTabName);
        
	}
    }
    structMgr.register(WriteBackDataReq._$info.name_hash, WriteBackDataReq, WriteBackDataReq._$info.name);

    export class OK_I extends Struct {
        public static _$info =  new StructInfo("pi_pt/util/platmgr.OK_I",1202749611, null, [new FieldInfo('value', 
    new EnumType(Type.Usize), null)]);
    
        public value: number;
    
        public bonDecode(bb:BonBuffer) {
            (<any>this).value = bb.readInt();
        }
    
        public bonEncode(bb:BonBuffer) {        
            bb.writeInt(this.value);
            
        }
    }
    structMgr.register(OK_I._$info.name_hash, OK_I, OK_I._$info.name);
    
    export class OK_S extends Struct {
        public static _$info =  new StructInfo("pi_pt/util/platmgr.OK_S",3702175770, null, [new FieldInfo('value', 
    new EnumType(Type.Str), null)]);
    
        public value: string;
    
        public bonDecode(bb:BonBuffer) {
            (<any>this).value = bb.readUtf8();
        }
    
        public bonEncode(bb:BonBuffer) {        
            bb.writeUtf8(this.value);
            
        }
    }
    structMgr.register(OK_S._$info.name_hash, OK_S, OK_S._$info.name);
    
    export class Req extends Struct {
        public static _$info =  new StructInfo("pi_pt/util/platmgr.Req",1052874625, null, [new FieldInfo('path', 
    new EnumType(Type.Str), null)]);
    
        public path: string;
    
        public bonDecode(bb:BonBuffer) {
            (<any>this).path = bb.readUtf8();
        }
    
        public bonEncode(bb:BonBuffer) {        
            bb.writeUtf8(this.path);
            
        }
    }
    structMgr.register(Req._$info.name_hash, Req, Req._$info.name);
    
    export class Error extends Struct {
        public static _$info =  new StructInfo("pi_pt/util/platmgr.Error",363239746, null, [new FieldInfo('code', 
    new EnumType(Type.Usize), null), new FieldInfo('info', 
    new EnumType(Type.Str), null)]);
    
        public code: number;
        public info: string;
    
        public bonDecode(bb:BonBuffer) {
            (<any>this).code = bb.readInt();
            (<any>this).info = bb.readUtf8();
        }
    
        public bonEncode(bb:BonBuffer) {        
            bb.writeInt(this.code);
                    
            bb.writeUtf8(this.info);
            
        }
    }
    structMgr.register(Error._$info.name_hash, Error, Error._$info.name);
    
    export class Ok extends Struct {
    
        public static _$info =  new StructInfo("pi_pt/util/platmgr.Ok",3420826729, null, []);
    
        public bonDecode(bb:BonBuffer) {
        }
    
        public bonEncode(bb:BonBuffer) {
        }
    }
    structMgr.register(Ok._$info.name_hash, Ok, Ok._$info.name);
