/**
 * _$rpc负责rpc路由，和响应结果
 * rpc函数有且仅有一个参数, 该参数必须是pi/struct/struct_mgr.Struct类型
 * rpc函数返回值类型也必须是Struct， 当无返回值时， 将默认构建一个pi/net/rpc_r.Ok的实例作为rpc的返回值， 当rpc函数内部抛出异常时， 将默认构建pi/net/rpc_r.Error的实例作为返回值
 */

declare var pi_modules;
import {Mgr as PtMgr} from "../rust/pi_db/mgr";
import {Mgr, Tr} from "../db/mgr";
import { Entrance } from "../entrance.s";
import {ServerNode} from "../rust/mqtt_tmp/server";
import {setMqttTopic, unsetMqttTopic} from "../rust/pi_serv/js_net";
import {} from "../net/fetch"; // 定义fetch接口(https://developer.mozilla.org/zh-CN/docs/Web/API/Fetch_API)到全局
import { Env } from "../../pi/lang/env";
declare var env: Env;
//事件通知
const _$notify = (e: any, mgr:any, _env: any) => {
    env = new Env();
    let dbMgr = new Mgr(new PtMgr(mgr), (<any>self).dbListen);
    env.dbMgr = dbMgr;
    env.other = new Map();
    dbMgr.read((tr: Tr) => {
        let it = tr.iter("memory", Entrance._$info.name, null, false, "");
        for (let elem of it) {
            let r = elem[1] as Entrance;
            if(r.note.get("event") === e.event_name){
				let lastPoint = r.path.lastIndexOf(".");
				let m = pi_modules[r.path.slice(0, lastPoint) + ".r"];
				if (!m) {
					throw new Error("mod not exist:" + r.path.slice(0, lastPoint) + ".r");
				}
				m.exports[r.path.slice(lastPoint + 1, r.path.length)](e)
            }
        }
    }, 1000)
}
(<any>self)._$notify = _$notify;

export interface NetEvent{
    event_name: string,
    connect_id: number,
}

export interface DbEvent{
    event_name: string,
    ware: string,
    tab: string,
}
(<any>ServerNode.prototype)["setTopic"] = function(topic,can_publish,can_subscribe){
    setMqttTopic(this, topic, can_publish, can_subscribe);
};

(<any>ServerNode.prototype)["unsetTopic"] = function(topic){
    unsetMqttTopic(this, topic);
};
