import {NetEvent, DbEvent} from "./event_server";
import {SESSION_WARE, DEFAULT_FILE_WARE} from "../constant";
import {TabMeta, EnumType, Type} from "../../pi/struct/sinfo";
import {dump as dump1} from "../rust/pi_serv/js_db";
import { Env } from "../../pi/lang/env";
declare var env: Env;

//#[event=net_connect]
export const connect = (e: NetEvent) => {
    console.log("net connect success11----------------------------------");
    env.dbMgr.write((tr) => { //连接成功，创建session表
        tr.alter(SESSION_WARE, e.connect_id + "_str", new TabMeta(new EnumType(Type.Str), new EnumType(Type.Str)));
        tr.alter(SESSION_WARE, e.connect_id + "_num", new TabMeta(new EnumType(Type.Str), new EnumType(Type.U32)));
    });
}

//#[event=net_connect_close]
export const close_connect = (e: NetEvent) => {
    console.log("net connect close success----------------------------------");
    env.dbMgr.write((tr) => { //断开连接，删除session表
        tr.alter(SESSION_WARE, e.connect_id + "_str", null);
        tr.alter(SESSION_WARE, e.connect_id + "_num", null);
    });
}

//#[event=rpc_net_connect]
export const rpc_connect = (e: NetEvent) => {
    console.log("rpc net connect success----------------------------------");
    env.dbMgr.write((tr) => { //连接成功，创建session表
        tr.alter(SESSION_WARE, e.connect_id + "_str", new TabMeta(new EnumType(Type.Str), new EnumType(Type.Str)));
        tr.alter(SESSION_WARE, e.connect_id + "_num", new TabMeta(new EnumType(Type.Str), new EnumType(Type.U32)));
    });
}

//#[event=rpc_net_connect_close]
export const rpc_close_connect = (e: NetEvent) => {
    console.log("rpc net connect close success----------------------------------");
    env.dbMgr.write((tr) => { //断开连接，删除session表
        tr.alter(SESSION_WARE, e.connect_id + "_str", null);
        tr.alter(SESSION_WARE, e.connect_id + "_num", null);
    });
}

// 使用文件数据库不在需要 dump
// //#[event=db_change]
// export const dump = (e: DbEvent) => {
//     if(e.ware === DEFAULT_FILE_WARE){
//         //console.log("dump----------------------------------");
//         dump1((<any>env).dbMgr.inner, e.ware, e.tab, `./dump/${DEFAULT_FILE_WARE}/${e.tab}`);
//     }
// }
