import { registerAsyncHandler} from "../rust/pi_serv/js_base";
import { JSGray } from "../rust/pi_serv/js_lib";
import { AsyncRequestHandler } from "../rust/pi_serv/js_async";
import { AsyncCfg } from "./server_cfg.s";
import { createNobjs} from "./init";
import { Entrance } from "../entrance.s";
import { createVMFactory } from "./util";
import { arcNewAsyncRequestHandler } from "../rust/pi_serv/js_base";
import { cfgMgr } from "../../pi/util/cfg";
import {Env} from "../../pi/lang/env";
declare var env: Env;

export let initOk = false;

const Path = "pi_pt/async/async_resp";

const initAsync = () => {
    let entrance: string[] = []; //rpc入口函数路径
    let asyncCfgs = cfgMgr.get(AsyncCfg._$info.name);
    let entranceCfgs = cfgMgr.get(Entrance._$info.name);
    if(!asyncCfgs || !entranceCfgs){
        return;
    }
    
    entranceCfgs.forEach((v: Entrance, _k) => {
        if(v.note.get("async") !== undefined){
            entrance.push(v.path);
            
        }
    });

    let map = new Map();

    let dbMgr = (<any>env.dbMgr).inner;
    asyncCfgs.forEach((v: AsyncCfg, k) => {
        let nobjs =  createNobjs(v.nobjs);
        for(let j = 0; j < entrance.length; j++){
            let topic = entrance[j];
            let file = topic.slice(0, topic.lastIndexOf("."));
            let handler = map.get(entrance[j]);
            if(!handler){
                let gray = JSGray.new(dbMgr, createVMFactory(topic, 128, 2, env.dbMgr, env.get("depend"), [Path + ".js", file + ".r.js"]), topic + "$async", nobjs);
                handler = arcNewAsyncRequestHandler(AsyncRequestHandler.new(gray));//创建handler， 同一js文件下的rpc函数， handler应该是同一个
                map.set(entrance[j], handler);
            }
            registerAsyncHandler(topic, handler); //注册一个异步处理器
        }
    });
}
initAsync();