import { Nobjs } from "../rust/pi_serv/js_lib";
import { Depend } from "../rust/pi_serv/depend";
import { Mgr as PtMgr} from "../rust/pi_db/mgr";
import { Mgr} from "../db/mgr";
import {GrayMgr} from "../rust/pi_serv/hotfix";
import {ServerNode} from "../rust/mqtt_tmp/server";
import {setMqttTopic, unsetMqttTopic} from "../rust/pi_serv/js_net";
import {} from "../net/fetch"; // 定义fetch接口(https://developer.mozilla.org/zh-CN/docs/Web/API/Fetch_API)到全局
import {Env} from "../../pi/lang/env";

declare var env: Env;

env = new Env();
env.dbMgr = new Mgr(new PtMgr((<any>self)._$db_mgr));
env.other = new Map();
env.set("depend", new Depend((<any>self)._$depend));

delete (<any>self)._$depend;
delete (<any>self)._$db_mgr;

(<any>ServerNode.prototype)["setTopic"] = function(topic,can_publish,can_subscribe){
    setMqttTopic(this, topic, can_publish, can_subscribe);
};

(<any>ServerNode.prototype)["unsetTopic"] = function(topic){
    unsetMqttTopic(this, topic);
};

//创建一个灰度管理器
let grayMgrNobjs = Nobjs.new();
export const grayMgr = GrayMgr.new((<Mgr>env.dbMgr).inner, grayMgrNobjs);

export const addNativeObj = (name: string, value: any, cfg: any, cloneFun: any) => {
    if(cloneFun){
        grayMgr.setObj(name, cloneFun(value).self, (<any>value).constructor._$info.name, name);
    }
    env.set(name, [value, cloneFun]);
    if (cfg._$listener) {
        for (let i = 0; i < cfg._$listener.length; i++) {
            cfg._$listener[i](value);
        }
        cfg._$listener = undefined;
    }
}

export const getNativeObj = (name: string): any => {
    return env.get(name);
}

export const createNobjs = (nobj_names: string[]): Nobjs => {
    let nobjs = Nobjs.new();
    if (!nobj_names) {
        return nobjs;
    }
    for (let j = 0; j < nobj_names.length; j++) {
        let obj = getNativeObj(nobj_names[j]);
        nobjs.setObj(nobj_names[j], obj.self, (<any>obj).constructor._$info.name, nobj_names[j]);
    }
    return nobjs;
}

export const nobjsPath = (nobj_names: string[]): string[] => {
    let ret: string[] = [];
    for (let j = 0; j < nobj_names.length; j++) {
        let obj = getNativeObj(nobj_names[j]);
        let r = (<any>obj).constructor._$info.name.slice(0, (<any>obj).constructor._$info.name.lastIndexOf("."));
        if(ret.indexOf(r) < 0){
            ret.push(r + ".js");
        }
    }
    return ret;
}

export const addNobjListener = (cfg: any, listener: (any) => void) => {
    if (cfg._$listener) {
        cfg._$listener.push(listener);
    } else {
        cfg._$listener = [];
        cfg._$listener.push(listener);
    }
}