/**
 * mqtt服务初始化
 * 根据配置创建mqtt服务
 */

import {mqttBind, cloneServerNode, TlsNetMgr, NetMgr as RawNetMgr, mqttBindTls,globalMqttBindTcpPorts} from "../rust/pi_serv/js_net";
import {MqttCfg, NetCfg_Enum, RawNetCfg, TlsNetCfg, GlobalMqttServerCfg} from "./server_cfg.s";
import { getNativeObj, addNativeObj, addNobjListener } from "./init";
import { cfgMgr } from "../../pi/util/cfg";
import * as X from "./net.a";
import { ServerNode } from "../rust/mqtt_tmp/server";

const initMqtt = () => {
	let mqttCfgs = cfgMgr.get(MqttCfg._$info.name);
	if(!mqttCfgs){
		return;
	}
	mqttCfgs.forEach((r: MqttCfg, _k) => {
		let mqttServer = ServerNode.new();
		addNativeObj(r.name, mqttServer, r, cloneServerNode);
	});
}

// const initGlobalMqtt = () => {
// 	let mqttCfgs = cfgMgr.get(GlobalMqttServerCfg._$info.name);
// 	if(!mqttCfgs){
//         return;
// 	}
// 	let i = 0;
// 	mqttCfgs.forEach((r: GlobalMqttServerCfg, _k) => {
// 		globalMqttBindTcpPorts(r.ip, r.port, r.recv_buffer_size, r.send_buffer_size, r.read_buffer_capacity, r.write_buffer_capacity, r.pool_size, r.stack_size, r.timeout, r.protocol);
// 		return;
// 	});
// }

initMqtt();
// initGlobalMqtt();