/**
 * netMgr
 */

import {NetMgr as RawNetManager, TlsNetMgr as TlsNetManager} from "../rust/pi_serv/js_net";
import { TlsNetMgr, RawNetMgr} from "./server_cfg.s";
import { addNativeObj} from "./init";
import { cfgMgr } from "../../pi/util/cfg";

const initNetMgr = () => {
    //raw
    let netCfg = cfgMgr.get(RawNetMgr._$info.name);
    if(netCfg){
        netCfg.forEach((v:RawNetMgr , k) => {
            addNativeObj(v.name, RawNetManager.new(), v, null);
        });
    }
    

    //tls
    let netCfgTls = cfgMgr.get(TlsNetMgr._$info.name);
    if(netCfgTls){
        netCfgTls.forEach((v:TlsNetMgr , k) => {
            addNativeObj(v.name, TlsNetManager.new(v.recvBuffSize), v, null);
        });
    }
    
    
}

initNetMgr();