/**
 * rpc服务初始化
 * 根据配置，创建rpc服务，并为服务绑定handler
 */
import {RpcService} from "../rust/rpc/service";
import { cloneServerNode, TopicHandler, cloneRpcServer, createRpcService} from "../rust/pi_serv/js_net";
import { ServerNode } from "../rust/mqtt_tmp/server";
import {RpcCfg} from "./server_cfg.s";
import { getNativeObj, addNativeObj, addNobjListener, grayMgr } from "./init";
import {Entrance} from "../entrance.s";
import { cfgMgr } from "../../pi/util/cfg";
import { addHandler } from "./rpc";
import {Env} from "../../pi/lang/env";
declare var env: Env;

const initRpc = () => {
    let entranceCfg = cfgMgr.get(Entrance._$info.name) as Map<number, Entrance>;//rpc入口函数路径
    if(!entranceCfg){
        return;
	}
    //遍历入口配置， 将rpc的配置过滤出来
    let entrance: Entrance[] = [];
    entranceCfg.forEach((v, k) => {
        if(v.note.get("rpc") !== undefined){
            entrance.push(v);
        }
	});
	
    //rpc服务配置，利用rpc服务配置创建rpc服务，并绑定handler
    let rpCfgs = cfgMgr.get(RpcCfg._$info.name) as Map<number, RpcCfg>; //rpc服务配置
    if(!rpCfgs){
        return;
    }
	let serviceMap = new Map();
	let i = 0;
    rpCfgs.forEach((rpc, _) => {
		if (i == 0) {
			addHandlers(entrance, rpc.nobjs, serviceMap);
		}
		i += 1;
		// addNativeObj(rpc.name, rpcServer, rpc, cloneRpcServer);//注册rpc服务
    });
}

const addHandlers = (entrance: Entrance[], _nobjs: string[], map: Map<string, RpcService>) => {
    for(let j = 0; j < entrance.length; j++){
        addHandler(entrance[j].path, _nobjs, map, env.dbMgr, env.get("depend"), grayMgr, entrance[j].note.get("rpc"));
    }
}

initRpc();
