import {HttpClient, HttpClientResponse} from "../rust/httpc";
import {postStringAsync, getStringAsync, createHttpClient, HttpClientOptions, HttpClientBody} from "../rust/pi_serv/js_httpc";

const fetch = (input: RequestInfo, init?: RequestInit): Promise<Response> =>{
    let client = createHttpClient('fetch', HttpClientOptions.default());
    let method = "Get";
    let body = null;
    if (init) {
        if (init.headers){
            for (let key in init.headers) {
                HttpClient.addHeaderSharedHttpc(client, key, init.headers[key]);
            }
        }
        if (init.body) {
            if (typeof init.body == "string"){
                body = HttpClientBody.bodyString(init.body as string);
            }else {
                throw new Error("body type error, it must is string"); // 暂时不支持body为其他类型
            }
        }else {
            body = HttpClientBody.bodyString("");
        }
        if (init.method) {
            method = init.method;
        }
        //其他属性： TODO
    }

    return new Promise((resolve, reject) => {
        if (method === "GET") {
            getStringAsync(client as HttpClient, input as string , body, (r: [HttpClient, HttpClientResponse])=>{
                if(((typeof r[1] === "string" && (<any>r[1]).endsWith("Result is Err")) || ( typeof r[1].self === "string" && (<any>r[1].self).endsWith("Result is Err")))){
                    reject(r[1] as any);
                }else {
                    resolve(r[1] as any);
                }
            });
        }else if (method === "POST") {
            postStringAsync(client as HttpClient, input as string , body, (r: [HttpClient, HttpClientResponse])=>{
                if(((typeof r[1] === "string" && (<any>r[1]).endsWith("Result is Err")) || ( typeof r[1].self === "string" && (<any>r[1].self).endsWith("Result is Err")))){
                    reject(new Response1(r[1])  as any);
                }else {
                    resolve(new Response1(r[1]) as any);
                }
            })
        }else {
            throw new Error("fetch type not supported: " + method);
        }
    });
}

export class Response1{
    status: number;
    _r: HttpClientResponse;

    constructor (_r: HttpClientResponse) {
        this._r = _r;
        this.status = _r.status();
    }

    text(){
        return this._r.text();
    }

    json(){
        return JSON.parse(this._r.text());
    }
}
if (!self.fetch) {
    self.fetch = fetch;
}
