import {Tr} from "../db/mgr";
import {SESSION_WARE} from "../constant";

export class Session{
    private id:number;
    private str_tab: string;
    private num_tab: string;

    constructor(id: number){
        this.id = id;
        this.str_tab = id + "_str";
        this.num_tab = id + "_num";
    }

    //设置session
    set(tr: Tr, key: string, value: string | number) {
        if(this.id === undefined){
            throw new Error("error: sessionid is not exist");
        }
        if (typeof value === "string"){
            tr.modify([{ware: SESSION_WARE, tab: this.str_tab, key: key, value: value}], 1000, false);
        }else{
            tr.modify([{ware: SESSION_WARE, tab: this.num_tab, key: key, value: value}], 1000, false);
        }
    }

    /**
     * 取session
     * @param tr 事务
     * @param key key
     * @param t 值类型 "string" | "number"
     */ 
    get(tr: Tr, key: string, t?: string): number | string{
        try {
            if (t === "string"){
                let r = tr.query([{ware: SESSION_WARE, tab: this.str_tab, key: key}], 1000, false);
                return r[0].value;
            }else if(t === "number"){
                let r = tr.query([{ware: SESSION_WARE, tab: this.num_tab, key: key}], 1000, false);
                return r[0].value;
            }else{
                let r = tr.query([{ware: SESSION_WARE, tab: this.str_tab, key: key}], 1000, false);
                if (r[0].value === undefined || r[0].value === null){
                    r = tr.query([{ware: SESSION_WARE, tab: this.num_tab, key: key}], 1000, false);
                }
                return r[0].value;
            }
        } catch (error) {
            console.log(error);
            return null;
        }
    }

    getId(): number {
        return this.id;
    }
}