
import {NativeObject, call} from "../vm/vm";
import {NObject} from "../vm/nobject";
import {StructInfo as SInfo} from "../../pi/struct/sinfo";
import * as bigInt from "../../pi/bigint/biginteger";
import {u128ToBuffer, u64ToBuffer} from "../../pi/bigint/util";
/**
* 全局唯一id生成器
*/
export class GuidGen extends NObject{
    static _$info = new SInfo("pi_pt/rust/guid/.GuidGen", 3694327039 , new Map(), []);    
    /**
    
    	* 构建全局唯一id生成器
    
    	* @param node_time 本地节点运行时长，单位纳秒
    
    	* @param node_id 本地节点编号
    
    	* @returns 返回全局唯一id生成器
    
    	*/
    /**
     * @param node_time:u64
     * @param node_id:u16
     * @return 
     */
    static new = (node_time:bigInt.BigInteger,node_id:number): GuidGen => {          
        (<any>node_time) = u64ToBuffer(node_time);
             
        let result = call(596751388,[ node_time,node_id ]);     
        (<any>result) = new GuidGen(result);
        
        return result; 
    }
}