
import {NativeObject, call} from "../vm/vm";
import {NObject} from "../vm/nobject";
import {StructInfo as SInfo} from "../../pi/struct/sinfo";
/**
* 32位hash值
*/
export class H32 extends NObject{
    static _$info = new SInfo("pi_pt/rust/hash_value/.H32", 961528204 , new Map(), []);    
    /**
    
        * 获取32位hash值的数组
    
        * @returns 返回32位hash值的数组
    
        */
    /**
     * @param self
     * @return [u8,4]
     */
    take = (): Uint8Array => {     
        let result = call(3776200155,[ this.self ]);     
        return result; 
    }    
    /**
    
        * 获取32位hash值的字符串
    
        * @returns 返回32位hash值的字符串
    
        */
    /**
     * @param self
     * @return String
     */
    tohex = (): string => {     
        return call(2655400174,[ this.self ]); 
    }    
    /**
    
        * 将32位hash值的数组，转换为32位hash值
    
        * @param buf 32位hash值的数组
    
        * @returns 返回32位hash值
    
        */
    /**
     * @param buf:&[u8]
     * @return hash_value::H32
     */
    static fromBuf = (buf:Uint8Array): H32 => {          
        let result = call(444306144,[ buf ]);     
        (<any>result) = new H32(result);
        
        return result; 
    }    
    /**
    
        * 将32位hash值的字符串，转换为32位hash值
    
        * @param hex 32位hash值的字符串
    
        * @returns 返回32位hash值
    
        */
    /**
     * @param hex:&str
     * @return hash_value::H32
     */
    static fromhex = (hex:string): H32 => {          
        let result = call(640799706,[ hex ]);     
        (<any>result) = new H32(result);
        
        return result; 
    }    
    /**
    
        * 比较另一个32位hash值
    
        * @param other 另一个32位hash值
    
        * @returns 返回比较结果，-1小于，0等于，1大于
    
        */
    /**
     * @param self
     * @param other:&H32
     * @return i8
     */
    cmp = (other:H32): number => {          
        (<any>other) = other.self;
        
        return call(4080635904,[ this.self,other ]); 
    }
}
/**
* 48位hash值
*/
export class H48 extends NObject{
    static _$info = new SInfo("pi_pt/rust/hash_value/.H48", 209715136 , new Map(), []);    
    /**
    
        * 获取48位hash值的数组
    
        * @returns 返回48位hash值的数组
    
        */
    /**
     * @param self
     * @return [u8,6]
     */
    take = (): Uint8Array => {     
        let result = call(702574989,[ this.self ]);     
        return result; 
    }    
    /**
    
        * 获取48位hash值的字符串
    
        * @returns 返回48位hash值的字符串
    
        */
    /**
     * @param self
     * @return String
     */
    tohex = (): string => {     
        return call(3679689648,[ this.self ]); 
    }    
    /**
    
        * 将48位hash值的数组，转换为48位hash值
    
        * @param buf 48位hash值的数组
    
        * @returns 返回48位hash值
    
        */
    /**
     * @param buf:&[u8]
     * @return hash_value::H48
     */
    static fromBuf = (buf:Uint8Array): H48 => {          
        let result = call(1365606331,[ buf ]);     
        (<any>result) = new H48(result);
        
        return result; 
    }    
    /**
    
        * 将48位hash值的字符串，转换为48位hash值
    
        * @param hex 48位hash值的字符串
    
        * @returns 返回48位hash值
    
        */
    /**
     * @param hex:&str
     * @return hash_value::H48
     */
    static fromhex = (hex:string): H48 => {          
        let result = call(3968952281,[ hex ]);     
        (<any>result) = new H48(result);
        
        return result; 
    }    
    /**
    
        * 比较另一个48位hash值
    
        * @param other 另一个48位hash值
    
        * @returns 返回比较结果，-1小于，0等于，1大于
    
        */
    /**
     * @param self
     * @param other:&H48
     * @return i8
     */
    cmp = (other:H48): number => {          
        (<any>other) = other.self;
        
        return call(3601455854,[ this.self,other ]); 
    }
}
/**
* 160位hash值
*/
export class H160 extends NObject{
    static _$info = new SInfo("pi_pt/rust/hash_value/.H160", 536126312 , new Map(), []);    
    /**
    
        * 获取160位hash值的数组
    
        * @returns 返回160位hash值的数组
    
        */
    /**
     * @param self
     * @return [u8,20]
     */
    take = (): Uint8Array => {     
        let result = call(3927864906,[ this.self ]);     
        return result; 
    }    
    /**
    
        * 获取160位hash值的字符串
    
        * @reutrns 返回160位hash值的字符串
    
        */
    /**
     * @param self
     * @return String
     */
    tohex = (): string => {     
        return call(1290828860,[ this.self ]); 
    }    
    /**
    
        * 将160位hash值的数组，转换为160位hash值
    
        * @param buf 160位hash值的数组
    
        * @returns 返回160位hash值
    
        */
    /**
     * @param buf:&[u8]
     * @return hash_value::H160
     */
    static fromBuf = (buf:Uint8Array): H160 => {          
        let result = call(3024861218,[ buf ]);     
        (<any>result) = new H160(result);
        
        return result; 
    }    
    /**
    
        * 将160位hash值的字符串，转换为160位hash值
    
        * @param hex 160位hash值的字符串
    
        * @returns 返回160位hash值
    
        */
    /**
     * @param hex:&str
     * @return hash_value::H160
     */
    static fromhex = (hex:string): H160 => {          
        let result = call(3933772904,[ hex ]);     
        (<any>result) = new H160(result);
        
        return result; 
    }    
    /**
    
        * 比较另一个160位hash值
    
        * @param other 另一个160位hash值
    
        * @returns 返回比较结果，-1小于，0等于，1大于
    
        */
    /**
     * @param self
     * @param other:&H160
     * @return i8
     */
    cmp = (other:H160): number => {          
        (<any>other) = other.self;
        
        return call(1395856100,[ this.self,other ]); 
    }
}
/**
* 256位hash值
*/
export class H256 extends NObject{
    static _$info = new SInfo("pi_pt/rust/hash_value/.H256", 2448676432 , new Map(), []);    
    /**
    
        * 获取256位hash值的数组
    
        * @returns 返回256位hash值的数组
    
        */
    /**
     * @param self
     * @return [u8,32]
     */
    take = (): Uint8Array => {     
        let result = call(4065712353,[ this.self ]);     
        return result; 
    }    
    /**
    
        * 获取256位hash值的字符串
    
        * @returns 返回256位hash值的字符串
    
        */
    /**
     * @param self
     * @return String
     */
    tohex = (): string => {     
        return call(4173242765,[ this.self ]); 
    }    
    /**
    
        * 将256位hash值的数组，转换为256位hash值
    
        * @param buf 256位hash值的数组
    
        * @param 返回256位hash值
    
        */
    /**
     * @param buf:&[u8]
     * @return hash_value::H256
     */
    static fromBuf = (buf:Uint8Array): H256 => {          
        let result = call(155840530,[ buf ]);     
        (<any>result) = new H256(result);
        
        return result; 
    }    
    /**
    
        * 将256位hash值的字符串，转换为256位hash值
    
        * @param hex 256位hash值的字符串
    
        * @param 返回256位hash值
    
        */
    /**
     * @param hex:&str
     * @return hash_value::H256
     */
    static fromhex = (hex:string): H256 => {          
        let result = call(1103597055,[ hex ]);     
        (<any>result) = new H256(result);
        
        return result; 
    }    
    /**
    
        * 比较另一个256位hash值
    
        * @param other 另一个256位hash值
    
        * @reutrns 返回比较结果，-1小于，0等于，1大于
    
        */
    /**
     * @param self
     * @param other:&H256
     * @return i8
     */
    cmp = (other:H256): number => {          
        (<any>other) = other.self;
        
        return call(234413511,[ this.self,other ]); 
    }
}
/**
* 512位hash值
*/
export class H512 extends NObject{
    static _$info = new SInfo("pi_pt/rust/hash_value/.H512", 154771902 , new Map(), []);    
    /**
    
        * 获取512位hash值的数组
    
        * @returns 返回512位hash值的数组
    
        */
    /**
     * @param self
     * @return [u8,64]
     */
    take = (): Uint8Array => {     
        let result = call(3659472819,[ this.self ]);     
        return result; 
    }    
    /**
    
        * 获取512位hash值的字符串
    
        * @returns 返回512位hash值的字符串
    
        */
    /**
     * @param self
     * @return String
     */
    tohex = (): string => {     
        return call(768602447,[ this.self ]); 
    }    
    /**
    
        * 将512位hash值的数组，转换为512位hash值
    
        * @param buf 512位hash值的数组
    
        * @returns 返回512位hash值
    
        */
    /**
     * @param buf:&[u8]
     * @return hash_value::H512
     */
    static fromBuf = (buf:Uint8Array): H512 => {          
        let result = call(3857186173,[ buf ]);     
        (<any>result) = new H512(result);
        
        return result; 
    }    
    /**
    
        * 将512位hash值的字符串，转换为512位hash值
    
        * @param hex 512位hash值的字符串
    
        * @returns 返回512位hash值
    
        */
    /**
     * @param hex:&str
     * @return hash_value::H512
     */
    static fromhex = (hex:string): H512 => {          
        let result = call(2370856657,[ hex ]);     
        (<any>result) = new H512(result);
        
        return result; 
    }    
    /**
    
        * 比较另一个512位hash值
    
        * @param other 另一个512位hash值
    
        * @returns 返回比较结果，-1小于，0等于，1大于
    
        */
    /**
     * @param self
     * @param other:&H512
     * @return i8
     */
    cmp = (other:H512): number => {          
        (<any>other) = other.self;
        
        return call(3293705496,[ this.self,other ]); 
    }
}
/**
* 520位hash值
*/
export class H520 extends NObject{
    static _$info = new SInfo("pi_pt/rust/hash_value/.H520", 1610417349 , new Map(), []);    
    /**
    
        * 获取520位hash值的数组
    
        * @returns 返回520位hash值的数组
    
        */
    /**
     * @param self
     * @return [u8,65]
     */
    take = (): Uint8Array => {     
        let result = call(3987195607,[ this.self ]);     
        return result; 
    }    
    /**
    
        * 获取520位hash值的字符串
    
        * @returns 返回520位hash值的字符串
    
        */
    /**
     * @param self
     * @return String
     */
    tohex = (): string => {     
        return call(1178325458,[ this.self ]); 
    }    
    /**
    
        * 将520位hash值的数组，转换为520位hash值
    
        * @param buf 520位hash值的数组
    
        * @returns 返回520位hash值
    
        */
    /**
     * @param buf:&[u8]
     * @return hash_value::H520
     */
    static fromBuf = (buf:Uint8Array): H520 => {          
        let result = call(57500088,[ buf ]);     
        (<any>result) = new H520(result);
        
        return result; 
    }    
    /**
    
        * 将520位hash值的字符串，转换为520位hash值
    
        * @param hex 520位hash值的字符串
    
        * @returns 返回520位hash值
    
        */
    /**
     * @param hex:&str
     * @return hash_value::H520
     */
    static fromhex = (hex:string): H520 => {          
        let result = call(1046314649,[ hex ]);     
        (<any>result) = new H520(result);
        
        return result; 
    }    
    /**
    
        * 比较另一个520位hash值
    
        * @param other 另一个520位hash值
    
        * @returns 返回比较结果，-1小于，0等于，1大于
    
        */
    /**
     * @param self
     * @param other:&H520
     * @return i8
     */
    cmp = (other:H520): number => {          
        (<any>other) = other.self;
        
        return call(1817272802,[ this.self,other ]); 
    }
}