
import {NativeObject, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
/**
* 批量静态资源文件
*/
export class FileBatch extends NObject{
    static _$info = new SInfo("pi_pt/rust/https/batch.FileBatch", 146565400 , new Map(), []);    
    /**
    
        * 指定文件根目录，构建指定的批量静态资源文件，可以是绝对路径或相对路径，如果为空串，则表示以当前运行时路径作为文件根目录
    
        * @param root 批量静态资源文件所在根路径
    
        * @returns 返回批量静态资源文件
    
        */
    /**
     * @param root:P
     * @return 
     */
    static newString = (root:string): FileBatch => {          
        let result = call(2717821527,[ root ]);     
        (<any>result) = new FileBatch(result);
        
        return result; 
    }    
    /**
    
        * 增加批量静态资源文件访问时的指定通用响应头
    
        * @param key 关键字
    
        * @param value 值
    
        * @returns 返回通用响应头数量
    
        */
    /**
     * @param self
     * @param key:&str
     * @param value:&str
     * @return usize
     */
    addGenRespHeader = (key:string,value:string): number => {               
        return call(3012164796,[ this.self,key,value ]); 
    }    
    /**
    
        * 移除指定通用响应头
    
        * @param key 关键字
    
        * @returns 返回通用响应头数量
    
        */
    /**
     * @param self
     * @param key:&str
     * @return usize
     */
    removeGenRespHeader = (key:string): number => {          
        return call(648785627,[ this.self,key ]); 
    }
}