
import {NativeObject, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
/**
* 有缓存的静态资源文件
*/
export class StaticFile extends NObject{
    static _$info = new SInfo("pi_pt/rust/https/file.StaticFile", 3348269405 , new Map(), []);    
    /**
    
        * 指定文件根目录，构建指定的静态资源文件，可以是绝对路径或相对路径，如果为空串，则表示以当前运行时路径作为文件根目录
    
        * @param root 静态资源文件所在根路径
    
        * @returns 返回有缓存的静态资源文件
    
        */
    /**
     * @param root:P
     * @return 
     */
    static newString = (root:string): StaticFile => {          
        let result = call(3779679042,[ root ]);     
        (<any>result) = new StaticFile(result);
        
        return result; 
    }    
    /**
    
        * 增加静态资源访问时的指定通用响应头
    
        * @param key 关键字
    
        * @param value 值
    
        * @returns 返回通用响应头数量
    
        */
    /**
     * @param self
     * @param key:&str
     * @param value:&str
     * @return usize
     */
    addGenRespHeader = (key:string,value:string): number => {               
        return call(1738064952,[ this.self,key,value ]); 
    }    
    /**
    
        * 移除静态资源访问时的指定通用响应头
    
        * @param key 关键字
    
        * @returns 返回通用响应头数量
    
        */
    /**
     * @param self
     * @param key:&str
     * @return usize
     */
    removeGenRespHeader = (key:string): number => {          
        return call(422874864,[ this.self,key ]); 
    }
}