
import {NativeObject, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {Mount} from "./mount"
/**
* 启动http协议的指定服务器
* @param handler 处理器，例如一个挂载器
* @param ip 绑定的服务器地址
* @param port 绑定的服务器端口
* @param keep_alive_timeout 长连接超时时长，单位毫秒，如果大于0，则表示支持http长连接
* @param handle_timeout 处理超时时长，单位毫秒
*/
/**
 * @param handler:H
 * @param ip:Atom
 * @param port:u16
 * @param keep_alive_timeout:usize
 * @param handle_timeout:u32
 */
export const startHttpMount = (handler:Mount,ip:string,port:number,keep_alive_timeout:number,handle_timeout:number) => {          
    (<any>handler) = handler.self;
         
    (<any>ip) = ip;
                   
    call(374744388,[ handler,ip,port,keep_alive_timeout,handle_timeout ]);
}
/**
* 启动https协议的指定服务器
* @param handler 处理器，例如一个挂载器
* @param ip 绑定的服务器地址
* @param port 绑定的服务器端口
* @param keep_alive_timeout 长连接超时时长，单位毫秒，如果大于0，则表示支持http长连接
* @param handle_timeout 处理超时时长，单位毫秒
* @param cert_file 证书文件路径
* @param key_file 密钥文件路径
*/
/**
 * @param handler:H
 * @param ip:Atom
 * @param port:u16
 * @param keep_alive_timeout:usize
 * @param handle_timeout:u32
 * @param cert_file:Atom
 * @param key_file:Atom
 */
export const startHttpsMount = (handler:Mount,ip:string,port:number,keep_alive_timeout:number,handle_timeout:number,cert_file:string,key_file:string) => {          
    (<any>handler) = handler.self;
         
    (<any>ip) = ip;
                        
    (<any>cert_file) = cert_file;
         
    (<any>key_file) = key_file;
    
    call(3415190104,[ handler,ip,port,keep_alive_timeout,handle_timeout,cert_file,key_file ]);
}