
import {NativeObject, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {StaticFile} from "./file"
import {StaticFileBatch} from "./files"
import {FileUpload} from "./upload"
import {FileBatch} from "./batch"
/**
* 挂载器
*/
export class Mount extends NObject{
    static _$info = new SInfo("pi_pt/rust/https/mount.Mount", 2373723440 , new Map(), []);    
    /**
    
        * 构建一个挂载器
    
        * @returns 返回挂载器
    
        */
    /**
     * @return 
     */
    static new = (): Mount => {     
        let result = call(1576795673,[  ]);     
        (<any>result) = new Mount(result);
        
        return result; 
    }    
    /**
    
        * 在指定路由上挂载指定的处理器，路由必须为绝对路径
    
        * @param route 路由
    
        * @param handler 处理器
    
        * @returns 返回挂载器
    
        */
    /**
     * @param self
     * @param route:&str
     * @param handler:H
     * @return &muthttps::mount::Mount
     */
    mountStaticFile = (route:string,handler:StaticFile): Mount => {               
        (<any>handler) = handler.self;
        
        let result = call(3977181471,[ this.self,route,handler ]);     
        (<any>result) = new Mount(result);
        
        return result; 
    }    
    /**
    
        * 在指定路由上挂载指定的处理器，路由必须为绝对路径
    
        * @param route 路由
    
        * @param handler 处理器
    
        * @returns 返回挂载器
    
        */
    /**
     * @param self
     * @param route:&str
     * @param handler:H
     * @return &muthttps::mount::Mount
     */
    mountStaticFileBatch = (route:string,handler:StaticFileBatch): Mount => {               
        (<any>handler) = handler.self;
        
        let result = call(4128314446,[ this.self,route,handler ]);     
        (<any>result) = new Mount(result);
        
        return result; 
    }    
    /**
    
        * 在指定路由上挂载指定的处理器，路由必须为绝对路径
    
        * @param route 路由
    
        * @param handler 处理器
    
        * @returns 返回挂载器
    
        */
    /**
     * @param self
     * @param route:&str
     * @param handler:H
     * @return &muthttps::mount::Mount
     */
    mountFileUpload = (route:string,handler:FileUpload): Mount => {               
        (<any>handler) = handler.self;
        
        let result = call(2869286636,[ this.self,route,handler ]);     
        (<any>result) = new Mount(result);
        
        return result; 
    }    
    /**
    
        * 在指定路由上挂载指定的处理器，路由必须为绝对路径
    
        * @param route 路由
    
        * @param handler 处理器
    
        * @returns 返回挂载器
    
        */
    /**
     * @param self
     * @param route:&str
     * @param handler:H
     * @return &muthttps::mount::Mount
     */
    mountFileBatch = (route:string,handler:FileBatch): Mount => {               
        (<any>handler) = handler.self;
        
        let result = call(1238254206,[ this.self,route,handler ]);     
        (<any>result) = new Mount(result);
        
        return result; 
    }
}