
/**
* SHA加密算法
*/
import {NativeObject, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import * as bigInt from "../../../pi/bigint/biginteger";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {u128ToBuffer, u64ToBuffer} from "../../../pi/bigint/util";
import {Vec} from "../def/vec"
/**
* SHA加密
* @param alg SHA加密算法类型
* @param data 待加密的数据
* @returns 返回加密数据
*/
/**
 * @param alg:DigestAlgorithm
 * @param data:&[u8]
 * @return Vec<u8>
 */
export const digest = (alg:DigestAlgorithm,data:Uint8Array): Vec => {               
    let result = call(3937242908,[ alg,data ]);     
    (<any>result) = new Vec(result);
    
    return result; 
}
export enum DigestAlgorithm{
SHA1,
SHA256,
SHA384,
SHA512
}