
/**
* 密钥hash消息认证码
*/
import {NativeObject, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import * as bigInt from "../../../pi/bigint/biginteger";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {u128ToBuffer, u64ToBuffer} from "../../../pi/bigint/util";
import {Vec} from "../def/vec"
/**
* 密钥hash消息认证码对象
*/
export class Hmac extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_crypto/hmac.Hmac", 1678658980 , new Map(), []);    
    /**
    
        * 使用指定的SHA加密算法和密钥，对数据进行签名
    
        * @param alg SHA加密算法类型
    
        * @param key 密钥
    
        * @param data 待签名的数据
    
        * @returns 返回签名
    
        */
    /**
     * @param alg:DigestAlgorithm
     * @param key:&[u8]
     * @param data:&[u8]
     * @return Vec<u8>
     */
    static sign = (alg:DigestAlgorithm,key:Uint8Array,data:Uint8Array): Vec => {                    
        let result = call(3800356447,[ alg,key,data ]);     
        (<any>result) = new Vec(result);
        
        return result; 
    }    
    /**
    
        * 验证通过指定SHA加密算法和密钥进行加密的签名
    
        * @param alg SHA加密算法类型
    
        * @param key 密钥
    
        * @param data 已签名的数据
    
        * @param signature 签名
    
        * @returns 返回验证签名是否成功
    
        */
    /**
     * @param alg:DigestAlgorithm
     * @param key:&[u8]
     * @param data:&[u8]
     * @param signature:&[u8]
     * @return bool
     */
    static verify = (alg:DigestAlgorithm,key:Uint8Array,data:Uint8Array,signature:Uint8Array): boolean => {                         
        return call(2199666057,[ alg,key,data,signature ]); 
    }
}
export enum DigestAlgorithm{
SHA1,
SHA256,
SHA384,
SHA512
}