
import {NativeObject, call, syncCall, callbacks, asyncCall} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import * as bigInt from "../../../pi/bigint/biginteger";
import {u64ToBuffer, u128ToBuffer} from "../../../pi/bigint/util";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {Mgr} from "../pi_db/mgr"
import {Nobjs} from "./js_lib"
import {VMFactory} from "../pi_vm/pi_vm_impl"
import {GrayTab} from "../gray"
//灰度管理器
export class GrayMgr extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/hotfix.GrayMgr", 3355816649 , new Map(), []);    
    /**
     * @param mgr:&Mgr
     * @param nobjs:&Nobjs
     * @return hotfix::GrayMgr
     */
    static new = (mgr:Mgr,nobjs:Nobjs): GrayMgr => {          
        (<any>mgr) = mgr.self;
             
        (<any>nobjs) = nobjs.self;
        
        let result = call(1942014446,[ mgr,nobjs ]);     
        (<any>result) = new GrayMgr(result);
        
        return result; 
    }    
    /**
     * @param self
     * @param key:&str
     * @param mgr:&Mgr
     * @param factor:VMFactory
     * @return bool
     */
    updateGray = (key:string,mgr:Mgr,factor:VMFactory): boolean => {               
        (<any>mgr) = mgr.self;
             
        (<any>factor) = factor.self;
        
        return call(2753091108,[ this.self,key,mgr,factor ]); 
    }    
    /**
     * @param self
     * @param key:&str
     * @return bool
     */
    hasGrayTab = (key:string): boolean => {          
        return call(2997074552,[ this.self,key ]); 
    }    
    /**
     * @param self
     * @param key:&str
     * @return Option<Arc<RwLock<gray::GrayTab<js_lib::JSGray>>>>
     */
    getGrayTab = (key:string): GrayTab => {          
        let result = call(4222745849,[ this.self,key ]);     
        if(result !== undefined && result !== null){         
                (<any>result) = new GrayTab(result);
                
        }
        
        return result; 
    }    
    /**
     * @param self
     * @param gray_tab:&Arc<RwLock<GrayTab<JSGray>>>
     * @return Result<(),String>
     */
    addGrayTab = (gray_tab:GrayTab): void => {          
        (<any>gray_tab) = gray_tab.self;
        
        let result = call(1272018599,[ this.self,gray_tab ]);          
        
        return result; 
    }    
    /**
     * @param self
     * @param _version:usize
     * @return bool
     */
    removeGray = (_version:number): boolean => {          
        return call(2013391265,[ this.self,_version ]); 
    }    
    /**
     * @param self
     * @param key:String
     * @param obj:&JSType
     * @param path:String
     * @param name:String
     * @return Result<bool,String>
     */
    setObj = (key:string,obj:any,path:string,name:string): boolean => {                         
        let result = call(56672718,[ this.self,key,obj,path,name ]);          
        
        return result; 
    }
}
export class GrayMgrMutax extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/hotfix.GrayMgrMutax", 646865374 , new Map(), []);
}
//
/**
 * @param gray_mgr:GrayMgr
 * @return Arc<Mutex<hotfix::GrayMgr>>
 */
export const graymgrToArc = (gray_mgr:GrayMgr): GrayMgr => {          
    (<any>gray_mgr) = gray_mgr.self;
    
    let result = call(3591490542,[ gray_mgr ]);     
    (<any>result) = new GrayMgr(result);
    
    return result; 
}
//监听depned的变化， 根据depend文件的变化修改灰度
/**
 * @param gray_mgr:Arc<Mutex<GrayMgr>>
 * @param path:String
 */
export const hotfixListen = (gray_mgr:GrayMgr,path:string) => {          
    (<any>gray_mgr) = gray_mgr.self;
         
    call(3668445806,[ gray_mgr,path ]);
}