
import {NativeObject, call, syncCall, callbacks, asyncCall} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import * as bigInt from "../../../pi/bigint/biginteger";
import {u64ToBuffer, u128ToBuffer} from "../../../pi/bigint/util";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {Vec} from "../def/vec"
import {ServerNode} from "../mqtt_tmp/server"
import {Event} from "../pi_db/db"
import {Mgr} from "../pi_db/mgr"
import {VMFactory} from "../pi_vm/pi_vm_impl"
import {Tr} from "../pi_db/mgr"
import {DB} from "../pi_db/memery_db"
import {DB as Lmdb} from "../pi_store/lmdb_file"
import {FileMemDB} from "../pi_store/file_mem_db"
import {TabMeta} from "../pi_db/db"
import {TabKV} from "../pi_db/db"
/**
* 封装类db迭代器， 是其由traiobj转化为具体类型（构建工具暂时不支持traitobj的构建）
*/
export class DBIter extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_db.DBIter", 3289224548 , new Map(), []);    
    /**
    
        * 迭代下一个记录
    
        * @param cb 迭代下一个记录的结果的异步回调，成功返回下一个记录的键值对，如果没有下一个记录，则返回空，失败返回原因描述
    
        * @returns 返回同步迭代下一个记录的结果，成功返回下一个记录的键值对，如果没有下一个记录，则返回空
    
        * @throws 失败则抛出原因描述
    
        */
    /**
     * @param self
     * @return Result<Option<(Arc<Vec<u8>>,Arc<Vec<u8>>)>,String>
     */
    
    next = ():[Vec,Vec] => {     
    
        let r = syncCall(3763610783,[ this.self ]);                          
                            if(r !== undefined && r !== null){                                  
                                                            (<any>r[0]) = new Vec(r[0]);
                                                                             
                                                            (<any>r[1]) = new Vec(r[1]);
                                                            
                            }
                            
                
        return r;
    }    
    /**
    
        * 迭代下一个对象
    
        * @param cb 迭代下一个对象的结果的异步回调，成功返回下一个记录的反序列化对象，如果没有下一个对象，则返回空，失败返回原因描述
    
        * @param js 当前虚拟机
    
        * @returns 返回同步迭代下一个对象的结果的异步回调，成功返回下一个记录的反序列化对象，如果没有下一个对象，则返回空
    
        * @throws 失败则抛出原因描述
    
        */
    /**
     * @param self
     * @return Result<Option<pi_vm::adapter::JSType>,String>
     */
    
    nextElem = ():any => {     
    
        let r = syncCall(2701929727,[ this.self ]);                          
                            if(r !== undefined && r !== null){                 
                                            
                            }
                            
                
        return r;
    }
}
//数据库监听器
export class DBToMqttMonitor extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_db.DBToMqttMonitor", 2627601653 , new Map(), []);    
    /**
     * @param mqtt_server:&ServerNode
     * @param cfg:&[u8]
     * @return Result<js_db::DBToMqttMonitor,bon::ReadBonErr>
     */
    static new = (mqtt_server:ServerNode,cfg:Uint8Array): DBToMqttMonitor => {          
        (<any>mqtt_server) = mqtt_server.self;
             
        let result = call(1993779671,[ mqtt_server,cfg ]);          
            (<any>result) = new DBToMqttMonitor(result);
            
        
        return result; 
    }
}
//数据库监听器
export class DBToGlobalMqttMonitor extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_db.DBToGlobalMqttMonitor", 1632158050 , new Map(), []);    
    /**
     * @param cfg:&[u8]
     * @return Result<js_db::DBToGlobalMqttMonitor,bon::ReadBonErr>
     */
    static new = (cfg:Uint8Array): DBToGlobalMqttMonitor => {          
        let result = call(4117819797,[ cfg ]);          
            (<any>result) = new DBToGlobalMqttMonitor(result);
            
        
        return result; 
    }
}
// 表的元信息
// pub fn tab_info(mgr: &Mgr, ware_name:String, tab_name: String) -> Option<Arc<TabMeta>> {
//     match mgr.tab_info(&Atom::from(ware_name), &Atom::from(tab_name)) {
//         Some(b) => b.tab_info(tab_name),
//         _ => None
//     }
// }
/*
* 数据库监听器
*/
export class JSDBMonitor extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_db.JSDBMonitor", 1495847839 , new Map(), []);    
    /**
     * @param self
     * @param e:Event
     * @param mgr:Mgr
     */
    notifyMonitor = (e:Event,mgr:Mgr) => {          
        (<any>e) = e.self;
             
        (<any>mgr) = mgr.self;
        
        call(1168492209,[ this.self,e,mgr ]);
    }    
    //构建一个监听器
    /**
     * @param handler:String
     * @param factory:VMFactory
     * @return js_db::JSDBMonitor
     */
    static new = (handler:string,factory:VMFactory): JSDBMonitor => {               
        (<any>factory) = factory.self;
        
        let result = call(2153620660,[ handler,factory ]);     
        (<any>result) = new JSDBMonitor(result);
        
        return result; 
    }
}
/**
* 获取数据库的迭代器
* @param tr 事务
* @param ware 库名
* @param tab 表名
* @param key 启始关键字
* @param descending 是否倒序
* @param _filter 过滤器，暂未使用
* @param cb 获取迭代器的结果的异步回调，成功返回数据库的迭代器，失败返回原因描述
* @returns 返回同步获取迭代器的结果，成功返回数据库的迭代器
* @throws 失败则抛出原因描述
*/
/**
 * @param tr:&Tr
 * @param ware:String
 * @param tab:String
 * @param key:Option<&[u8]>
 * @param descending:bool
 * @param _filter:Option<String>
 * @return Result<js_db::DBIter,String>
 */

export const iterDb = (tr:Tr,ware:string,tab:string,key:Uint8Array,descending:boolean,_filter:string):DBIter => {     
     
    (<any>tr) = tr.self;
                   
    if(key !== null && key !== undefined){         
    }
              
    if(_filter !== null && _filter !== undefined){         
    }
    
    let r = syncCall(1967373661,[ tr,ware,tab,key,descending,_filter ]);                          
                        (<any>r) = new DBIter(r);
                        
            
    return r;
}
/**
 * @param mgr:&Mgr
 * @return pi_db::mgr::Mgr
 */
export const cloneDbMgr = (mgr:Mgr): Mgr => {          
    (<any>mgr) = mgr.self;
    
    let result = call(1420275781,[ mgr ]);     
    (<any>result) = new Mgr(result);
    
    return result; 
}
// 注册内存数据库
/**
 * @param mgr:&Mgr
 * @param prefix:String
 * @param ware:DB
 * @return bool
 */
export const registerMemeryDb = (mgr:Mgr,prefix:string,ware:DB): boolean => {          
    (<any>mgr) = mgr.self;
              
    (<any>ware) = ware.self;
    
    return call(1905006775,[ mgr,prefix,ware ]); 
}
// 注册文件数据库
/**
 * @param mgr:&Mgr
 * @param prefix:String
 * @param ware:Lmdb
 * @return bool
 */
export const registerFileDb = (mgr:Mgr,prefix:string,ware:DB): boolean => {          
    (<any>mgr) = mgr.self;
              
    (<any>ware) = ware.self;
    
    return call(3038249291,[ mgr,prefix,ware ]); 
}
/**
 * @param mgr:&Mgr
 * @param prefix:String
 * @param ware:FileMemDB
 * @return bool
 */
export const registerFileMemDb = (mgr:Mgr,prefix:string,ware:FileMemDB): boolean => {          
    (<any>mgr) = mgr.self;
              
    (<any>ware) = ware.self;
    
    return call(2215620835,[ mgr,prefix,ware ]); 
}
/**
 * @param mgr:&Mgr
 * @return Vec<String>
 */
export const getAllWares = (mgr:Mgr): Vec => {          
    (<any>mgr) = mgr.self;
    
    let result = call(360427781,[ mgr ]);     
    (<any>result) = new Vec(result);
    
    return result; 
}
/**
 * @param meta:Arc<TabMeta>
 * @return Vec<u8>
 */
export const getTabmetaBuffer = (meta:TabMeta): Vec => {          
    (<any>meta) = meta.self;
    
    let result = call(2573413979,[ meta ]);     
    (<any>result) = new Vec(result);
    
    return result; 
}
//new TabKV
/**
 * @param ware:&str
 * @param tab:&str
 * @param key:&[u8]
 * @param value:&[u8]
 * @return pi_db::db::TabKV
 */
export const tabkvWithValue = (ware:string,tab:string,key:Uint8Array,value:Uint8Array): TabKV => {                         
    let result = call(2097131752,[ ware,tab,key,value ]);     
    (<any>result) = new TabKV(result);
    
    return result; 
}
//new TabKV
/**
 * @param ware:&str
 * @param tab:&str
 * @param key:&[u8]
 * @return pi_db::db::TabKV
 */
export const tabkvNew = (ware:string,tab:string,key:Uint8Array): TabKV => {                    
    let result = call(1247562096,[ ware,tab,key ]);     
    (<any>result) = new TabKV(result);
    
    return result; 
}
//TabKV get_value
/**
 * @param tabkv:&TabKV
 * @return Option<Arc<Vec<u8>>>
 */
export const tabkvGetValue = (tabkv:TabKV): Vec => {          
    (<any>tabkv) = tabkv.self;
    
    let result = call(1579404380,[ tabkv ]);     
    if(result !== undefined && result !== null){         
            (<any>result) = new Vec(result);
            
    }
    
    return result; 
}
/**
 * @param tr:&Tr
 * @param ware:String
 * @return Vec<String>
 */
export const listAllTables = (tr:Tr,ware:string): Vec => {          
    (<any>tr) = tr.self;
         
    let result = call(3169463176,[ tr,ware ]);     
    (<any>result) = new Vec(result);
    
    return result; 
}
/**
* 修改数据库元信息
* @param tr 事务
* @param ware 库名
* @param tab 表名
* @param meta_buf 元信息
* @param cb 创建、修改或删除表的结果的异步回调，成功返回空，失败返回原因描述
* @returns 返回同步创建、修改或删除表的结果，成功返回空
* @throws 失败则抛出原因描述
*/
/**
 * @param tr:&Tr
 * @param ware:String
 * @param tab:String
 * @param meta_buf:Option<&[u8]>
 * @return Result<(),String>
 */

export const alter = (tr:Tr,ware:string,tab:string,meta_buf:Uint8Array):void => {     
     
    (<any>tr) = tr.self;
                   
    if(meta_buf !== null && meta_buf !== undefined){         
    }
    
    let r = syncCall(2680255887,[ tr,ware,tab,meta_buf ]);                          
            
    return r;
}
/**
* 修改数据库记录
* @param tr 事务
* @param items 对象数组
* @param lock_time 修改的锁超时时长，单位毫秒
* @param read_lock 是否读锁
* @param cb 修改结果的异步回调，成功返回空，失败返回原因描述
* @returns 返回同步修改结果，成功返回空
* @throws 失败则抛出原因描述
*/
/**
 * @param tr:&Tr
 * @param items:&JSType
 * @param lock_time:Option<usize>
 * @param read_lock:bool
 * @return Result<(),String>
 */

export const modify = (tr:Tr,items:any,lock_time:number,read_lock:boolean):void => {     
     
    (<any>tr) = tr.self;
              
    if(lock_time !== null && lock_time !== undefined){         
    }
         
    let r = syncCall(2725879080,[ tr,items,lock_time,read_lock ]);                          
            
    return r;
}
/**
* 查询数据库记录
* @param tr 事务
* @param items 关键字数组
* @param lock_time 修改的锁超时时长，单位毫秒
* @param read_lock 是否读锁
* @param cb 查询结果的异步回调，成功查询到关键字对应的记录，则返回对象数组，否则返回空，失败返回原因描述
* @returns 返回同步查询结果，成功查询到关键字对应的记录，则返回对象数组，否则返回空
* @throws 失败则抛出原因描述
*/
/**
 * @param tr:&Tr
 * @param items:&JSType
 * @param lock_time:Option<usize>
 * @param read_lock:bool
 * @return Result<pi_vm::adapter::JSType,String>
 */

export const query = (tr:Tr,items:any,lock_time:number,read_lock:boolean):any => {     
     
    (<any>tr) = tr.self;
              
    if(lock_time !== null && lock_time !== undefined){         
    }
         
    let r = syncCall(583163851,[ tr,items,lock_time,read_lock ]);                          
                        
            
    return r;
}
/**
* 获取表的记录数量
* @param tr 事务
* @param ware_name 库名
* @param tab_name 表名
* @param cb 获取表的记录数量结果的异步回调，成功返回记录数量，失败返回原因描述
* @returns 返回同步获取表的记录数量的结果，成功返回记录数量
* @throws 失败则抛出原因描述
*/
/**
 * @param tr:&Tr
 * @param ware_name:&str
 * @param tab_name:&str
 * @return Result<usize,String>
 */

export const tabSize = (tr:Tr,ware_name:string,tab_name:string):number => {     
     
    (<any>tr) = tr.self;
              
    let r = syncCall(2986122496,[ tr,ware_name,tab_name ]);                          
            
    return r;
}
/**
 * @param mgr:&Mgr
 * @param monitor:DBToMqttMonitor
 */
export const registerDbToMqttMonitor = (mgr:Mgr,monitor:DBToMqttMonitor) => {          
    (<any>mgr) = mgr.self;
         
    (<any>monitor) = monitor.self;
    
    call(1869880364,[ mgr,monitor ]);
}
/**
 * @param mgr:&Mgr
 * @param monitor:DBToGlobalMqttMonitor
 */
export const registerDbToGlobalMqttMonitor = (mgr:Mgr,monitor:DBToGlobalMqttMonitor) => {          
    (<any>mgr) = mgr.self;
         
    (<any>monitor) = monitor.self;
    
    call(1719526885,[ mgr,monitor ]);
}
/**
* 将指定表的所有记录备份到指定的文件
* @param mgr 表库及事务管理器
* @param ware 库名
* @param tab 表名
* @param file 文件的路径
* @param cb 将指定表的所有记录保存到指定的文件的结果的异步回调，成功返回空，失败返回原因描述
* @returns 返回同步将指定表的所有记录保存到指定的文件的结果，成功返回空
* @throws 失败则抛出原因描述
*/
/**
 * @param mgr:&Mgr
 * @param ware:String
 * @param tab:String
 * @param file:String
 * @return Result<(),String>
 */

export const dump = (mgr:Mgr,ware:string,tab:string,file:string):void => {     
     
    (<any>mgr) = mgr.self;
                   
    let r = syncCall(4281318477,[ mgr,ware,tab,file ]);                          
            
    return r;
}
/**
* 将指定表的备份文件的所有记录恢复到指定的表
* @param mgr 表库及事务管理器
* @param ware 库名
* @param tab 表名
* @param file 文件的路径
* @param cb 将将指定表的备份文件的所有记录恢复到指定的表的结果的异步回调，成功返回空，失败返回原因描述
* @returns 返回同步将指定表的备份文件的所有记录恢复到指定的表的结果，成功返回空
* @throws 失败则抛出原因描述
*/
/**
 * @param mgr:&Mgr
 * @param ware:String
 * @param tab:String
 * @param file:String
 * @return Result<(),String>
 */

export const restore = (mgr:Mgr,ware:string,tab:string,file:string):void => {     
     
    (<any>mgr) = mgr.self;
                   
    let r = syncCall(479322726,[ mgr,ware,tab,file ]);                          
            
    return r;
}
/**
 * @param mgr:&Mgr
 * @param monitor:JSDBMonitor
 */
export const registerDbJsDbMonitor = (mgr:Mgr,monitor:JSDBMonitor) => {          
    (<any>mgr) = mgr.self;
         
    (<any>monitor) = monitor.self;
    
    call(2176133173,[ mgr,monitor ]);
}
export class DBWare extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_db.DBWare", 1675843967 , new Map(), []);
}