
import {NativeObject, call, syncCall, callbacks, asyncCall} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import * as bigInt from "../../../pi/bigint/biginteger";
import {u64ToBuffer, u128ToBuffer} from "../../../pi/bigint/util";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
import {Mgr} from "../pi_db/mgr"
import {VMFactory} from "../pi_vm/pi_vm_impl"
import {GrayTab} from "../gray"
import {GuidGen} from "../guid"
/**
* 本地对象表
*/
export class Nobjs extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_lib.Nobjs", 1422904849 , new Map(), []);    
    /**
    
        * 构建本地对象表
    
        * @returns 返回本地对象表
    
        */
    /**
     * @return 
     */
    static new = (): Nobjs => {     
        let result = call(1099259475,[  ]);     
        (<any>result) = new Nobjs(result);
        
        return result; 
    }    
    /**
    
        * 设置NativeObject， obj应该是本地对象的所有权, 如果灰度表中存在名为key的对象， 将会覆盖
    
        */
    /**
     * @param self
     * @param key:String
     * @param obj:&JSType
     * @param path:String
     * @param name:String
     * @return Result<bool,String>
     */
    setObj = (key:string,obj:any,path:string,name:string): boolean => {                         
        let result = call(1332820780,[ this.self,key,obj,path,name ]);          
        
        return result; 
    }
}
/**
* 灰度对象
*/
export class JSGray extends NObject{
    static _$info = new SInfo("pi_pt/rust/pi_serv/js_lib.JSGray", 2566315655 , new Map(), []);    
    /**
    
        * 构建灰度对象
    
        * @param mgr 表库及事务管理器
    
        * @param name 灰度对象名
    
        * @param nobjs 本地对象表
    
        * @returns 返回灰度对象
    
        */
    /**
     * @param mgr:&Mgr
     * @param factory:VMFactory
     * @param name:&str
     * @param nobjs:&Nobjs
     * @return 
     */
    static new = (mgr:Mgr,factory:VMFactory,name:string,nobjs:Nobjs): JSGray => {          
        (<any>mgr) = mgr.self;
             
        (<any>factory) = factory.self;
                  
        (<any>nobjs) = nobjs.self;
        
        let result = call(2697841501,[ mgr,factory,name,nobjs ]);     
        (<any>result) = new JSGray(result);
        
        return result; 
    }    
    /**
    
        * 设置NativeObject， obj应该是本地对象的所有权, 如果灰度表中存在名为key的对象， 将会覆盖
    
        */
    /**
     * @param self
     * @param key:String
     * @param obj:&JSType
     * @param path:String
     * @param name:String
     * @return Result<bool,String>
     */
    setObj = (key:string,obj:any,path:string,name:string): boolean => {                         
        let result = call(691063210,[ this.self,key,obj,path,name ]);          
        
        return result; 
    }
}
/**
* 创建灰度表
*/
/**
 * @param gray:JSGray
 * @return Arc<RwLock<gray::GrayTab<js_lib::JSGray>>>
 */
export const createGrayTab = (gray:JSGray): GrayTab => {          
    (<any>gray) = gray.self;
    
    let result = call(3635855143,[ gray ]);     
    (<any>result) = new GrayTab(result);
    
    return result; 
}
/**
* 获取全局唯一id
* @param guid 全局唯一id生成器
* @param ctrl_id 本地节点编号
* @returns 返回全局唯一id
*/
/**
 * @param guid:&GuidGen
 * @param ctrl_id:u16
 * @return u128
 */
export const guidGen = (guid:GuidGen,ctrl_id:number): bigInt.BigInteger => {          
    (<any>guid) = guid.self;
         
    let result = call(3557646357,[ guid,ctrl_id ]);     
    (<any>result) = bigInt(result);
    
    return result; 
}
/**
* 比较两个BonBuffer
* @param b1 BonBuffer
* @param b2 BonBuffer
* @returns 返回比较结果，-1表示小于，0表示相同，1表示大于
*/
/**
 * @param b1:&[u8]
 * @param b2:&[u8]
 * @return Option<i32>
 */
export const bonbufCmp = (b1:Uint8Array,b2:Uint8Array): number => {               
    let result = call(3906048478,[ b1,b2 ]);     
    if(result !== undefined && result !== null){         
    }
    
    return result; 
}