
import {NativeObject, Error, syncCall, call} from "../../vm/vm";
import {NObject} from "../../vm/nobject";
import {StructInfo as SInfo} from "../../../pi/struct/sinfo";
/*
* Rpc连接
*/
export class RpcConnect extends NObject{
    static _$info = new SInfo("pi_pt/rust/rpc/connect.RpcConnect", 3111750691 , new Map(), []);    
    //获取连接的本地ip
    /**
     * @param self
     * @return Option<String>
     */
    getLocalIp = (): string => {     
        let result = call(4030884866,[ this.self ]);     
        if(result !== undefined && result !== null){         
        }
        
        return result; 
    }    
    //获取连接的本地端口
    /**
     * @param self
     * @return Option<u16>
     */
    getLocalPort = (): number => {     
        let result = call(711780732,[ this.self ]);     
        if(result !== undefined && result !== null){         
        }
        
        return result; 
    }    
    //获取连接的对端ip
    /**
     * @param self
     * @return Option<String>
     */
    getRemoteIp = (): string => {     
        let result = call(747133793,[ this.self ]);     
        if(result !== undefined && result !== null){         
        }
        
        return result; 
    }    
    //获取连接的对端端口
    /**
     * @param self
     * @return Option<u16>
     */
    getRemotePort = (): number => {     
        let result = call(1246857552,[ this.self ]);     
        if(result !== undefined && result !== null){         
        }
        
        return result; 
    }    
    //关闭当前连接
    /**
     * @param self
     * @param reason:Option<String>
     */
    close = (reason:string) => {          
        if(reason !== null && reason !== undefined){         
        }
        
        call(1299557669,[ this.self,reason ]);
    }
}