/**
 * 默认数据库
 */

// ================================================ 导入
import { Forelet } from '../../../../pi/widget/forelet';
import { Widget } from '../../../../pi/widget/widget';
import { AuthEnum } from '../../../server/data/db/auth.s';
import { getStore } from '../../store/memstore';

// ================================================ 导出
export const forelet = new Forelet();

interface Props {
    activePage: any;  // 当前活跃的页面
    pageList: any[]; // 默认过滤器
    rightBox:boolean;  // 是否显示rightbox页面
}
const PAGE = {
    database: 'database', // 数据库
    shell: 'shellFunc', // shell查询
    rpc: 'rpcFunc', // rpc操作
    httpRpc: 'httpRpcFunc', // http rpc 操作
    topic:'topicSub', // topic主题
    log: 'logHistory',  // 日志查看
    user: 'userManage', // 用户管理
    dataTableMigration: 'migration' // 数据表迁移
};

// tslint:disable-next-line:completed-docs
export class Home extends Widget {
    public ok: () => void;
    public props: Props;
    constructor() {
        super();
        this.props = {
            pageList: [
                { name: '数据库', page: PAGE.database, img:'chart.png', op:AuthEnum.DBRO },
                { name: 'mqtt rpc', page: PAGE.rpc, img:'chart.png', op:AuthEnum.RPC },
                { name: 'http rpc', page: PAGE.httpRpc, img:'chart.png', op:AuthEnum.RPC },
                { name: 'topic订阅', page: PAGE.topic, img:'chart.png', op:AuthEnum.SUB },
                { name: '数据表迁移', page: PAGE.dataTableMigration, img:'chart.png', op:AuthEnum.SUB },
                { name: 'web shell', page: PAGE.shell, img:'chart.png', op:AuthEnum.SHELL }
            ],
            activePage: {},
            rightBox:true
        };
        // const power = getStore('ownerPower',[]);
        // 默认超级权限
        const power = [0,1,2,3,4,5,6];
        this.props.pageList = this.props.pageList.filter(item => {
            return power.indexOf(item.op) > -1;
        });
        this.props.activePage = this.props.pageList[0];
    }

    // 切换默认过滤器页面
    public changePage(num: number) {
        this.props.activePage = this.props.pageList[num];
        this.paint();
    }
}