import { WebShell } from '../../../pi_pt/rust/pi_serv/webshell';
import {Env} from "../../../pi/lang/env";
import { Tr } from '../../../pi_pt/db/mgr';
import { Session } from '../../../pi_pt/net/session';
import { ResultStr } from '../../utils/result.s';

declare var env: Env;

// #[rpc=rpcServer]
export const createNewShell = (cmd: string): ResultStr => {
    let res = new ResultStr;
    let userName;
    const sess: Session = env.get('session');
    env.dbMgr.read((tr: Tr) => {
        userName = sess.get(tr, 'userName');
    });

    if (!userName) {
        res.code = 2;
        res.msg = 'user not login';
        return res;
    }

    let shell: WebShell;
    
    if (!env.get(`${userName}_shell`)) {
        let w = WebShell.new();
        env.set(`${userName}_shell`, w);
        shell = w;
    }

    let resp = shell.exec(cmd);
    res.code = 1;
    res.msg = resp;

    return res;
}